;;*EDEN* MODULE Calculette
;; une petite calculette en notation polonaise inverse

 (set! Calc (make-instance Calculatrice))







;;*EDEN*

;;*EDEN* CLASSE Calculatrice

(defclass Calculatrice
    (super> Object)
    (fields>
        (pile)
        (touches)
        (afficheur)
        (etat)
    )
)







;;*EDEN*

;;*EDEN* METHODE init Calculatrice

(defmethod Calculatrice (init self)
  (body>
    (init $super)
    (set! @pile (make-instance CalcPile))
    (set! @etat 'fini)
    (let* ((theWin (make-instance CalcWindow 
                        'top 50 'left 10
                        'height 250 'width 300
                        'calculatrice self
                         'name "calculatrice"))
           (afficheur (set! @afficheur (make-instance StringPaneWithBorder
                                'name 'afficheur 'title ""
                                'left 10 'top 10 'height 25 'width 60
                                'partOf theWin)))
           (b1 (make-instance CalcBoutonNum
                  'name 'b1
                  'left 10 'top 100 'height 30 'width 30
                  'partOf theWin 'title "1"
                  'calculatrice self))
           (b2 (make-instance CalcBoutonNum
                  'name 'b2
                  'left 45 'top 100 'height 30 'width 30
                  'partOf theWin 'title "2"
                  'calculatrice self))
           (b3 (make-instance CalcBoutonNum
                  'name 'b3
                  'left 80 'top 100 'height 30 'width 30
                  'partOf theWin 'title "3"
                  'calculatrice self))
           (b4 (make-instance CalcBoutonNum
                  'name 'b4
                  'left 10 'top 135 'height 30 'width 30
                  'partOf theWin 'title "4"
                  'calculatrice self))
           (b5 (make-instance CalcBoutonNum
                  'name 'b5
                  'left 45 'top 135 'height 30 'width 30
                  'partOf theWin 'title "5"
                  'calculatrice self))
           (b6 (make-instance CalcBoutonNum
                  'name 'b6
                  'left 80 'top 135 'height 30 'width 30
                  'partOf theWin 'title "6"
                  'calculatrice self))
           (b7 (make-instance CalcBoutonNum
                  'name 'b7
                  'left 10 'top 170 'height 30 'width 30
                  'partOf theWin 'title "7"
                  'calculatrice self))
           (b8 (make-instance CalcBoutonNum
                  'name 'b8
                  'left 45 'top 170 'height 30 'width 30
                  'partOf theWin 'title "8"
                  'calculatrice self))
           (b9 (make-instance CalcBoutonNum
                  'name 'b9
                  'left 80 'top 170 'height 30 'width 30
                  'partOf theWin 'title "9"
                  'calculatrice self))
           (b0 (make-instance CalcBoutonNum
                  'name 'b0
                  'left 10 'top 205 'height 30 'width 30
                  'partOf theWin 'title "0"
                  'calculatrice self))
           (dot (make-instance Button
                  'name 'dot
                  'left 45 'top 205 'height 30 'width 30
                  'partOf theWin 'title "."))
           (enter (make-instance CalcBoutonEnter
                  'name 'enter
                  'left 10 'top 65 'height 30 'width 65
                  'partOf theWin 'title "Enter"
                  'calculatrice self))
           (reset (make-instance CalcBoutonReset
                  'name 'reset
                  'left 80 'top 65 'height 30 'width 30
                  'partOf theWin 'title "C"
                  'calculatrice self))
           (b+    (make-instance CalcBoutonOp
                  'name '+ 
                  'left 115 'top 65 'height 30 'width 30
                  'partOf theWin 'title "+"
                  'calculatrice self))
           (b-    (make-instance CalcBoutonOp
                  'name '-
                  'left 115 'top 100 'height 30 'width 30
                  'partOf theWin 'title "-"
                  'calculatrice self))
           (b*    (make-instance CalcBoutonOp
                  'name '*
                  'left 115 'top 135 'height 30 'width 30
                  'partOf theWin 'title "*"
                  'calculatrice self))
           (b/    (make-instance CalcBoutonOp
                  'name '/
                  'left 115 'top 170 'height 30 'width 30
                  'partOf theWin 'title "/"
                  'calculatrice self))
       ) ;; fin des variables du let
     (afficher self)
      )  ;; fin du let
    )
)




;;*EDEN*

;;*EDEN* METHODE num Calculatrice

(defmethod Calculatrice (num self v)
    (body>
          (if (eq? @etat 'fini)
             (empiler @pile v)
             (let ((r (depiler @pile)))
                (empiler @pile (+ v (* r 10)))))
         (set! @etat nil)
          (afficher self)
    )
)





;;*EDEN*

;;*EDEN* METHODE enter Calculatrice

(defmethod Calculatrice (enter self)
    (body>
          (empiler @pile 0)
          (afficher self)
    )
)



;;*EDEN*

;;*EDEN* METHODE reset Calculatrice

(defmethod Calculatrice (reset self)
    (body>
          (reset @pile)
          (set! @etat 'fini)
          (afficher self)
    )
)



;;*EDEN*

;;*EDEN* METHODE operation Calculatrice

(defmethod Calculatrice (operation self symbop)
    (body>
       (if (>= (nbOperandes @pile) 2)
          (let* ((v1 (depiler @pile))
                 (v2 (depiler @pile))
                 (op (symbol-value symbop nil)))
         ;     (print "v1 = " v1 "v2 = " v2)
              (empiler @pile (op v2 v1))
              (set! @etat 'fini)
              (afficher self))
          (print "impossible d'appliquer " symbop))
    )
)






;;*EDEN*

;;*EDEN* METHODE afficher Calculatrice

(defmethod Calculatrice (afficher self)
    (body>
         (let* ((r (or (sommet @pile) 0))
                (v (number->string r)))
           (setTitle @afficheur v)
           (update @afficheur))
    )
)





;;*EDEN*

;;*EDEN* CLASSE CalcPile

(defclass CalcPile
    (super> Collection)
    (fields>
        (content)
    )
)





;;*EDEN*

;;*EDEN* METHODE empiler CalcPile

(defmethod CalcPile (empiler self v)
    (body>
         (set! @content (cons v @content))
    )
)



;;*EDEN*

;;*EDEN* METHODE depiler CalcPile

(defmethod CalcPile (depiler self)
    (body>
          (let ((v (car @content)))
             (set! @content (cdr @content))
             v)
    )
)



;;*EDEN*

;;*EDEN* METHODE sommet CalcPile

(defmethod CalcPile (sommet self)
    (body>
          (car @content)
    )
)




;;*EDEN*

;;*EDEN* METHODE vide? CalcPile

(defmethod CalcPile (vide? self)
    (body>
          (null? @content)
    )
)


;;*EDEN*

;;*EDEN* METHODE reset CalcPile

(defmethod CalcPile (reset self)
    (body>
          (set! @content nil)
    )
)




;;*EDEN*

;;*EDEN* METHODE nbOperandes CalcPile

(defmethod CalcPile (nbOperandes self)
    (body>
          (length @content)
    )
)


;;*EDEN*

;;*EDEN* CLASSE CalcBouton

(defclass CalcBouton
    (super> Button)
    (fields>
        (calculatrice)
    )
)



;;*EDEN*

;;*EDEN* CLASSE CalcBoutonNum

(defclass CalcBoutonNum
    (super> CalcBouton)
    (fields>
    )
)





;;*EDEN*

;;*EDEN* METHODE init CalcBoutonNum

(defmethod CalcBoutonNum (init self)
    (body>
          (init $super)
         (set! @action 
            (lambda (w b)
              (num @calculatrice (asNumber @title))))
    )
)




;;*EDEN*

;;*EDEN* CLASSE CalcBoutonReset

(defclass CalcBoutonReset
    (super> CalcBouton)
    (fields>
    )
)


;;*EDEN*

;;*EDEN* METHODE init CalcBoutonReset

(defmethod CalcBoutonReset (init self)
    (body>
         (init $super)
         (set! @action 
            (lambda (w b)
              (reset @calculatrice)))
    )
)

;;*EDEN*

;;*EDEN* CLASSE CalcBoutonEnter


(defclass CalcBoutonEnter
    (super> CalcBouton)
    (fields>
    )
)



;;*EDEN*

;;*EDEN* METHODE init CalcBoutonEnter

(defmethod CalcBoutonEnter (init self)
    (body>
         (init $super)
         (set! @action 
            (lambda (w b)
              (enter @calculatrice)))
    )
)


;;*EDEN*

;;*EDEN* CLASSE CalcBoutonOp

(defclass CalcBoutonOp
    (super> CalcBouton)
    (fields>
    )
)


;;*EDEN*

;;*EDEN* METHODE init CalcBoutonOp

(defmethod CalcBoutonOp (init self)
    (body>
         (init $super)
         (set! @action 
            (lambda (w b)
              (operation @calculatrice (getname self))))
   )
)


;;*EDEN*

;;*EDEN* CLASSE CalcWindow

(defclass CalcWindow
    (super> Window)
    (fields>
        (calculatrice) 
    )
)

;;*EDEN*

;;*EDEN* METHODE keyDown CalcWindow

(defmethod CalcWindow (keyDown self x y)
  (body>
    (cond
     ((and (> x 47)(< x 58))
        (num @calculatrice (- x 48)))
     ((= x 3) (enter @calculatrice)) ;; enter sur le MAC
     ((= x 27) (reset @calculatrice)) ;; reset sur le MAC
     ((= x 43) (operation @calculatrice '+))
     ((= x 42) (operation @calculatrice '*))
     ((= x 45) (operation @calculatrice '-))
     ((= x 47) (operation @calculatrice '/))
     (else (keyDown $super x y)))
))



;;*EDEN*

;;*EDEN* FIN
